> For the complete documentation index, see [llms.txt](https://docs.rierino.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rierino.com/devops/microservices/building-blocks/data-sources/shared-states/mongodb-collection.md).

# MongoDB Collection

## Manager Parameters

| Parameter           | Definition                                                                                                                                        | Example                     | Default                   |
| ------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------- | --------------------------- | ------------------------- |
| system              | Name of the [system ](/devops/microservices/building-blocks/systems-integrations.md#mongodb)which defines MongoDB service details (uri, database) | {uri:"mongodb://127.0.0.1"} | master.mongo.uri/database |
| collection          | Name of the MongoDB collection to store details                                                                                                   | product                     | \[state manager alias]    |
| journalCollection   | Name of the MongoDB collection to store state changes                                                                                             | product\_journal            | -                         |
| keepJournal         | Alternative to journalCollection parameter, automatically using "draft\_journal" suffix for the journal collection                                | true                        | false                     |
| bypassDocValidation | Whether MongoDB should bypass document validation during updates                                                                                  | true                        | false                     |

This state manager supports [CallSP](broken://pages/0a3jLM4TdCuK7kEQqgi2) action of write event handler, where command can be either of deleteOne, deleteMany, updateOne or updateMany and input contents can include following fields:

* **filter:** Filter to pass for deleting or updating records (e.g. {"data.status": "D"})
* **update:** Update contents to pass for updating records (e.g. {"$set": {"data.status": "A"}})
* **options:** Delete or update options to pass (e.g. {"upsert": true})


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.rierino.com/devops/microservices/building-blocks/data-sources/shared-states/mongodb-collection.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
